module vsmColor
 use vsmConst

 implicit none

 ! definitions of defalut color
 ! Isosurf
 real, dimension(3, vsmMaxIsosurf), parameter :: vsmIsoDefAmb = reshape( (/0.8, 0.4, 0.4, 0.4, 0.8, 0.4, &
  0.4, 0.4, 0.8, 0.4, 0.8, 0.8, 0.8, 0.8, 0.4/), (/3, vsmMaxIsosurf/))
 real, dimension(3, vsmMaxIsosurf), parameter :: vsmIsoDefDif = reshape ( (/1.0, 0.5, 0.5, 0.5, 1.0, 0.5, &
  0.5,0.5,1.0, 0.5, 1.0, 1.0, 1.0, 1.0, 0.5/), (/3, vsmMaxIsosurf/))
 real, dimension(3, vsmMaxIsosurf), parameter :: vsmIsoDefSpec = reshape((/1.0, 1.0, 1.0, 1.0, 1.0, 1.0, &
  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0/), (/3, vsmMaxIsosurf/))
 real, dimension(vsmMaxIsosurf), parameter :: vsmIsoDefShin = (/80,80,80,80,80/)
 real, parameter :: iso_defa_alpha = 1.0

 ! slice
 real, parameter :: vsmSliceDefAmb = 0.5, vsmSliceDefDif = 0.8, vsmSliceDefSpec = 0.8
 real, parameter :: vsmSliceDefShin = 85
 real(kind=vdp), dimension(4), parameter :: vsmDefPlaneEq = (/0.0_vdp, 0.0_vdp, 1.0_vdp, 0.0_vdp/)
 real, parameter :: vsmSliceDefAlpha = 1.0

 ! Volume Rendering
 real, parameter :: vsmVolDefAmb = 0.5, vsmVolDefDif = 0.8, vsmVolDefSpec = 0.8, vsmVolDefShin = 50.0

 ! arrows
 real(kind=vdp), parameter :: vsmDefArrowRad = 0.1_vdp, vsmDefArrowLen = 1.0_vdp
 real, dimension(3), parameter :: vsmArAmb = (/0.0, 0.5, 0.75/), vsmArDif = (/0.0,0.5,0.75/), vsmArSpec = (/0.5,0.5,0.75/)
 real, dimension(3), parameter:: vsmArcAmb = (/0.35,0.35,0.0/), vsmArcDif = (/0.75,0.75,0.0/), vsmArcSpec = (/0.75,0.75,0.75/)
 real, parameter :: vsmArwShin = 50.0

 ! Particle
 real, dimension(3, vsmMaxPtcl), parameter :: vsmPtclDefAmb = reshape((/0.5, 0.5, 0.5, 0.6, 0.5, 0.5/), &
   (/3, vsmMaxPtcl/))
 real, dimension(3, vsmMaxPtcl), parameter :: vsmPtclDefDif = reshape((/0.75, 0.75, 0.75, 0.9, 0.75, 0.75/), &
   (/3, vsmMaxPtcl/))
 real, dimension(3, vsmMaxPtcl), parameter :: vsmPtclDefSpec = reshape((/0.6, 0.6, 0.6, 0.8, 0.6, 0.6/), &
   (/3, vsmMaxPtcl/))
 real, dimension(vsmMaxPtcl), parameter :: vsmPtclDefShin = (/75, 75/)
 real(kind=vdp), parameter :: vsmDefPtclRad = 0.1_vdp

 ! light
 real, dimension(3, vsmMaxLight), parameter :: vsmLightDefPos = reshape((/1.0, 0.0, 0.5, 0.0, 1.0, 0.5, &
   0.0, -1.0, -0.5, -1.0, 0.0, -0.5/), (/3, vsmMaxLight/))

 real, dimension(3, vsmMaxLight), parameter :: vsmLightDefAmb = reshape((/0.5, 0.5, 0.5, 0.5, 0.5, 0.5, &
   0.5, 0.5, 0.5, 0.75, 0.75, 0.75/), (/3, vsmMaxLight/))
 real, dimension(3, vsmMaxLight), parameter :: vsmLightDefDif = reshape((/0.75, 0.75, 0.75, 0.75, 0.75, 0.75, &
   0.75, 0.75, 0.75, 0.75, 0.75, 0.75/), (/3, vsmMaxLight/))
 real, dimension(3, vsmMaxLight), parameter :: vsmLightSpec = reshape((/0.7, 0.7, 0.7, 0.7, 0.7, 0.7, &
   0.7, 0.7, 0.7, 0.7, 0.7, 0.7/), (/3, vsmMaxLight/))

 real, dimension(3), parameter :: vsmFrameColor = (/1.0, 1.0, 1.0/)
 real, dimension(3), parameter :: vsmFSAmb = (/0.5, 0.5, 0.5/)
 real, dimension(3), parameter :: vsmFSDif = (/0.75, 0.75, 0.75/)
 real, dimension(3), parameter :: vsmFSSpec = (/0.6, 0.6, 0.6/)
 real, parameter :: vsmFSShin = 75

end module vsmColor

